#!/usr/bin/env python3
# -*- coding: utf-8 -*-

"""This is **SLIS** (reads *slice*), a core task of the image suggestions data pipeline:
to recommend images for Wikipedia article **sections** that don't have one.

SLIS applies two principal algorithms on top of datasets generated by the
`section alignment <https://section-alignment-image-suggestions.readthedocs.io/>`_ and
`section topics <https://section-topics.readthedocs.io/>`_ projects.

Given a language and a Wikipedia article section:

- the former algorithm retrieves images that already exist in the corresponding section of other languages
- the latter takes the section's `wikilinks <https://en.wikipedia.org/wiki/H:WIKILINK>`_ and
  looks up images that are connected to them via several properties, typically Wikidata ones.

We consider section alignment-based suggestions to be fairly relevant in general,
since they represent a projection of community-curated content.
On the other hand, the more connections a wikilink has, the more confident a section topics-based suggestion is.
"""

import argparse

from pyspark.sql import DataFrame, SparkSession
from pyspark.sql import functions as F
from pyspark.sql.types import NullType

from image_suggestions import (
    alignment_slis,
    overused_images,
    shared,
    topic_slis,
    unillustratable,
)


# Spark settings for development on stat boxes.
# They should mirror SLIS' production DAG properties:
# https://gitlab.wikimedia.org/repos/data-engineering/airflow-dags/-/blob/main/platform_eng/dags/slis_dag.py
DEV_SPARK_SETTINGS = {
    'spark.driver.cores': 2,
    'spark.driver.memory': '8g',
    'spark.executor.cores': 4,
    'spark.executor.memory': '8g',
    'spark.dynamicAllocation.maxExecutors': 64,
    'spark.sql.shuffle.partitions': 256,
    'spark.sql.sources.partitionOverwriteMode': 'dynamic',
}

# This threshold is based on the *Average scores per confidence rating* graph at
# https://docs.google.com/spreadsheets/d/1LUInOc-gZeJpTOiTYsjuovspazHCPSccuJZzy8WOhOg/edit?usp=sharing,
# which shows a correlation between human ratings and dataset scores.
# NOTE Wipes out roughly 80% of total suggestions
CONFIDENCE_THRESHOLD = 69

SECTIONS_DENYLIST_PARQUET = 'section_topics/section_titles_denylist'


def gather_suggestions(
    spark: SparkSession,
    hive_db: str,
    weekly_snapshot: str,
    section_topics_parquet: str,
    section_alignment_suggestions_parquet: str,
    section_images_parquet: str,
    sections_denylist_parquet: str,
) -> DataFrame:
    """Gather the full section-level image suggestions dataset.

    :param spark: an active Spark session
    :param hive_db: a `Data Lake <https://wikitech.wikimedia.org/wiki/Analytics/Data_Lake>`_'s
      Hive database name
    :param weekly_snapshot: a ``YYYY-MM-DD`` date
    :param section_topics_parquet: a HDFS path to a parquet generated by :mod:`section_topics.pipeline`
    :param section_alignment_suggestions_parquet: a HDFS path to a parquet generated by :mod:`imagerec.recommendation`
    :param section_images_parquet: a HDFS path to a parquet generated by :mod:`imagerec.article_images`
    :param sections_denylist_parquet: a HDFS path to a parquet generated by
      :mod:`section_topics.scripts.gather_section_titles_denylist`
    :return: the dataframe of:

        - wiki_db (string) - wiki project
        - target_qid (string) - page Wikidata QID
        - target_page_rev_id (bigint): page revision ID
        - target_page_id (bigint) - page ID
        - target_page_title (string) - page title, in original case and underscored
        - target_section_index (int) - section numerical index, starts from 0
        - target_section_heading (string) - page section, in URL anchor format.
          More details in :func:`section_topics.pipeline.wikitext_headings_to_anchors`
        - suggested_image (string) - Commons page title, in original case and underscored
        - kind (array<string>) - ``istype-section-alignment``, ``istype-section-topics-wikidata-image``,
          ``istype-section-topics-commons-category``, ``istype-section-topics-lead-image``, and/or
          ``istype-section-topics-depicts`` tags
        - topic_qid (string) - topic Wikidata QID
        - origin_wikis (array<string>) - wikis where the image was found.
          ``None`` for suggestions based on section topics only
        - confidence (double) - suggestion confidence score
    """
    section_alignment = alignment_slis.get(
        spark, weekly_snapshot, section_alignment_suggestions_parquet
    )
    section_topics = topic_slis.get(
        spark, hive_db, weekly_snapshot, section_topics_parquet
    )
    suggestions = combine_suggestions(section_alignment, section_topics)
    suggestions = prune_suggestions(
        spark,
        weekly_snapshot,
        section_images_parquet,
        sections_denylist_parquet,
        suggestions,
    )

    return suggestions


def combine_suggestions(
    section_alignment: DataFrame, section_topics: DataFrame
) -> DataFrame:
    """Combine suggestions from :mod:`image_suggestions.section_alignment_images` and
    :mod:`image_suggestions.section_topics_images`.

    :param section_alignment: a dataframe of section alignment-based suggestions
      as output by :func:`image_suggestions.section_alignment_images.get`
    :param section_topics: a dataframe of section topics-based suggestions
      as output by :func:`image_suggestions.section_topics_images.get`
    :return: the dataframe of combined suggestions, same schema as :func:`gather_suggestions`
    """
    return (
        section_alignment.join(
            section_topics,
            on=[
                'wiki_db',
                'target_page_id',
                'target_section_heading',
                'suggested_image',
            ],
            how='outer',
        )
        .select(
            'wiki_db',
            F.coalesce(section_alignment.target_qid, section_topics.target_qid).alias(
                'target_qid'
            ),
            F.coalesce(
                section_alignment.target_page_rev_id, section_topics.target_page_rev_id
            ).alias('target_page_rev_id'),
            'target_page_id',
            F.coalesce(
                section_alignment.target_page_title, section_topics.target_page_title
            ).alias('target_page_title'),
            F.coalesce(
                section_alignment.target_section_index,
                section_topics.target_section_index,
            ).alias('target_section_index'),
            'target_section_heading',
            'suggested_image',
            F.array_except(
                F.array(section_alignment.kind, section_topics.kind),
                F.array(F.lit(None).cast(NullType())),
            ).alias(shared.KIND_COLNAME),
            'topic_qid',
            'origin_wikis',
            # assign a confidence score (within a 0-100 range) based on the source of the suggestion;
            # if it matches just 1 source (e.g. section_alignment), it'll have that source's
            # confidence (e.g. 100 * (1 - (1 - 80 / 100)) = 90); if it matches multiple
            # (e.g. section_topics and section_alignment), it's going to be a combined OR probability
            # (e.g. 100 * (1 - (1 - 80 / 100) * (1 - 56 / 100)) = 91)
            # in other words: more sources confirming the suggestion = more confidence
            F.round(
                F.lit(100)
                * (
                    F.lit(1)
                    - (
                        F.lit(1)
                        - F.when(
                            section_alignment.confidence.isNotNull(),
                            section_alignment.confidence,
                        ).otherwise(0)
                        / F.lit(100)
                    )
                    * (
                        F.lit(1)
                        - F.when(
                            section_topics.confidence.isNotNull(),
                            section_topics.confidence,
                        ).otherwise(0)
                        / F.lit(100)
                    )
                )
            ).alias('confidence'),
        )
        .distinct()
    )


def prune_suggestions(
    spark: SparkSession,
    weekly_snapshot: str,
    section_images_parquet: str,
    sections_denylist_parquet: str,
    suggestions: DataFrame,
) -> DataFrame:
    """Filter out all irrelevant suggestions.

    :param spark: an active Spark session
    :param weekly_snapshot: a ``YYYY-MM-DD`` date
    :param section_images_parquet: a HDFS path to a parquet generated by :mod:`imagerec.article_images`
    :param sections_denylist_parquet: a HDFS path to a parquet generated by
      :mod:`section_topics.scripts.gather_section_titles_denylist`
    :param suggestions: a dataframe of raw suggestions as output by :func:`combine_suggestions`
    :return: the filtered ``suggestions`` dataframe, same schema as :func:`gather_suggestions`
    """
    suggestions = prune_non_illustratable_item_ids(spark, weekly_snapshot, suggestions)
    suggestions = prune_non_illustratable_sections(
        spark, sections_denylist_parquet, suggestions
    )
    suggestions = prune_sections_with_images(spark, section_images_parquet, suggestions)
    suggestions = prune_suggestions_already_on_page(spark, weekly_snapshot, suggestions)
    suggestions = prune_overused_images(spark, weekly_snapshot, suggestions)
    suggestions = prune_images_in_placeholder_categories(spark, suggestions)
    suggestions = prune_suggestions_with_disallowed_substrings(suggestions)
    suggestions = prune_suggestions_with_disallowed_suffixes(suggestions)

    return suggestions


def prune_non_illustratable_item_ids(
    spark: SparkSession, weekly_snapshot: str, suggestions: DataFrame
) -> DataFrame:
    """Filter out articles with Wikidata QIDs that aren’t suitable for getting suggestions.

    Calls :func:`image_suggestions.unillustratable.get_non_illustratable_item_ids`.

    :param spark: an active Spark session
    :param weekly_snapshot: a ``YYYY-MM-DD`` date
    :param suggestions: a dataframe of suggestions as output by :func:`combine_suggestions`
    :return: the filtered ``suggestions`` dataframe, same schema as :func:`gather_suggestions`
    """
    non_illustratable_item_ids = unillustratable.get_non_illustratable_item_ids(
        spark, weekly_snapshot
    )

    return (
        suggestions
        # get rid of unillustratable pages (e.g. instances of list etc.)
        .join(
            non_illustratable_item_ids.alias('non_illustratable_pages'),
            on=[F.col('non_illustratable_pages.item_id') == suggestions.target_qid],
            how='left_anti',
        )
        # get rid of unillustratable topics (e.g. instances of list etc.)
        .join(
            non_illustratable_item_ids.alias('non_illustratable_topics'),
            on=[F.col('non_illustratable_topics.item_id') == suggestions.topic_qid],
            how='left_anti',
        )
    )


def prune_non_illustratable_sections(
    spark: SparkSession, sections_denylist_parquet: str, suggestions: DataFrame
) -> DataFrame:
    """Filter out sections that aren't suitable for getting suggestions.

    Calls :func:`image_suggestions.unillustratable.get_non_illustratable_sections`.

    :param spark: an active Spark session
    :param sections_denylist_parquet: a HDFS path to a parquet generated by
      :mod:`section_topics.scripts.gather_section_titles_denylist`
    :param suggestions: a dataframe of suggestions as output by :func:`combine_suggestions`
    :return: the filtered ``suggestions`` dataframe, same schema as :func:`gather_suggestions`
    """
    non_illustratable_sections = unillustratable.get_non_illustratable_sections(
        spark,
        sections_denylist_parquet,
        suggestions,
        suggestions.wiki_db,
        suggestions.target_section_heading,
    )

    return suggestions.join(
        non_illustratable_sections,
        on=[
            non_illustratable_sections.wiki_db == suggestions.wiki_db,
            non_illustratable_sections.section_heading
            == suggestions.target_section_heading,
        ],
        how='left_anti',
    )


def prune_sections_with_images(
    spark: SparkSession, section_images_parquet: str, suggestions: DataFrame
) -> DataFrame:
    """Filter out suggestions for a section that already has an image.

    Calls :func:`image_suggestions.unillustratable.get_section_images`.

    :param spark: an active Spark session
    :param section_images_parquet: a HDFS path to a parquet generated by :mod:`imagerec.article_images`
    :param suggestions: a dataframe of suggestions as output by :func:`combine_suggestions`
    :return: the filtered ``suggestions`` dataframe, same schema as :func:`gather_suggestions`
    """
    sections_with_images = unillustratable.get_section_images(
        spark, section_images_parquet
    )

    return suggestions.join(
        sections_with_images,
        on=[
            sections_with_images.wiki_db == suggestions.wiki_db,
            sections_with_images.page_id == suggestions.target_page_id,
            sections_with_images.section_heading == suggestions.target_section_heading,
        ],
        how='left_anti',
    )


def prune_suggestions_already_on_page(
    spark: SparkSession, weekly_snapshot: str, suggestions: DataFrame
) -> DataFrame:
    """Filter out suggestions that already exist somewhere else in the same page.

    Anti-join suggestions with image links as output by :func:`image_suggestions.shared.load_imagelinks`.

    :param spark: an active Spark session
    :param weekly_snapshot: a ``YYYY-MM-DD`` date
    :param suggestions: a dataframe of suggestions as output by :func:`combine_suggestions`
    :return: the filtered ``suggestions`` dataframe, same schema as :func:`gather_suggestions`
    """
    monthly_snapshot = shared.get_monthly_snapshot(weekly_snapshot)
    existing_images = shared.load_imagelinks(spark, monthly_snapshot)

    return suggestions.join(
        existing_images,
        on=[
            existing_images.wiki_db == suggestions.wiki_db,
            existing_images.article_id == suggestions.target_page_id,
            existing_images.image_title == suggestions.suggested_image,
        ],
        how='left_anti',
    )


def prune_overused_images(
    spark: SparkSession, weekly_snapshot: str, suggestions: DataFrame
) -> DataFrame:
    """Filter out overused images.

    Calls :func:`image_suggestions.overused_images.get`.

    :param spark: an active Spark session
    :param weekly_snapshot: a ``YYYY-MM-DD`` date
    :param suggestions: a dataframe of suggestions as output by :func:`combine_suggestions`
    :return: the filtered ``suggestions`` dataframe, same schema as :func:`gather_suggestions`
    """
    monthly_snapshot = shared.get_monthly_snapshot(weekly_snapshot)
    overused = overused_images.get(spark, monthly_snapshot)

    return suggestions.join(
        F.broadcast(overused),
        on=[
            overused.wiki_db == suggestions.wiki_db,
            overused.page_title == suggestions.suggested_image,
        ],
        how='left_anti',
    )


def prune_images_in_placeholder_categories(
    spark: SparkSession, suggestions: DataFrame
) -> DataFrame:
    """Filter out images that belong to placeholder Commons categories.

    Calls :func:`image_suggestions.unillustratable.get_images_in_placeholder_categories`.

    :param spark: an active Spark session
    :param weekly_snapshot: a ``YYYY-MM-DD`` date
    :param suggestions: a dataframe of suggestions as output by :func:`combine_suggestions`
    :return: the filtered ``suggestions`` dataframe, same schema as :func:`gather_suggestions`
    """
    images_in_placeholder_categories = (
        unillustratable.get_images_in_placeholder_categories(spark)
    )

    return suggestions.join(
        images_in_placeholder_categories,
        on=[images_in_placeholder_categories.page_title == suggestions.suggested_image],
        how='left_anti',
    )


def prune_suggestions_with_disallowed_substrings(suggestions: DataFrame) -> DataFrame:
    """Filter out image file names that may be icons or placeholders.

    Calls :func:`image_suggestions.unillustratable.get_disallowed_substrings_regex`.

    :param suggestions: a dataframe of suggestions as output by :func:`combine_suggestions`
    :return: the filtered ``suggestions`` dataframe, same schema as :func:`gather_suggestions`
    """
    return suggestions.where(
        suggestions.suggested_image.rlike(
            unillustratable.get_disallowed_substrings_regex()
        )
        == False
    )


def prune_suggestions_with_disallowed_suffixes(suggestions: DataFrame) -> DataFrame:
    """Filter out image file extensions that typically hold valid images.

    Calls :func:`image_suggestions.unillustratable.get_allowed_suffixes_regex`.

    :param suggestions: a dataframe of suggestions as output by :func:`combine_suggestions`
    :return: the filtered ``suggestions`` dataframe, same schema as :func:`gather_suggestions`
    """
    return suggestions.where(
        suggestions.suggested_image.rlike(unillustratable.get_allowed_suffixes_regex())
    )


def filter_by_score(suggestions: DataFrame, threshold: int) -> DataFrame:
    """Filter out suggestions with confidence score below the given threshold.

    :param suggestions: a dataframe of suggestions as output by :func:`gather_suggestions`
    :param threshold: a confidence score threshold
    :return: the ``suggestions`` dataframe with confidence score
      equal or greater than the given threshold.
      Same schema as :func:`gather_suggestions`
    """
    return suggestions.where(suggestions.confidence >= threshold)


def format_suggestions(suggestions: DataFrame) -> DataFrame:
    """Compose the output dataset.

    Rename column names, drop irrelevant columns, add a dataset ID and origin wiki columns.

    :param suggestions: a dataframe of suggestions as output by :func:`gather_suggestions`
    :return: the dataframe of:

        - wiki (string) - article candidate's wiki project
        - item_id (string) - page Wikidata QID
        - section_index (int) - section numerical index, starts from 0
        - section_heading (string) - page section, in URL anchor format.
          More details in :func:`section_topics.pipeline.wikitext_headings_to_anchors`
        - title (string) - page title, in original case and underscored
        - image (string) - Commons page title, in original case and underscored
        - kind (array<string>) - ``istype-section-alignment``, ``istype-section-topics-wikidata-image``,
          ``istype-section-topics-commons-category``, ``istype-section-topics-lead-image``, and/or
          ``istype-section-topics-depicts`` tags
        - found_on (array<string>) - wikis where the image was found.
          ``None`` for suggestions based on section topics only
        - confidence (double) - suggestion confidence score
        - page_id (bigint) - page ID
        - page_rev (bigint): page revision ID
        - id (string) - unique dataset ID
        - origin_wiki (string) - image suggestion's wiki project, i.e., ``commonswiki``
    """
    return suggestions.select(
        suggestions.wiki_db.alias('wiki'),
        suggestions.target_qid.alias('item_id'),
        suggestions.target_section_index.alias('section_index'),
        suggestions.target_section_heading.alias('section_heading'),
        suggestions.target_page_title.alias('title'),
        suggestions.suggested_image.alias('image'),
        'kind',
        suggestions.origin_wikis.alias('found_on'),
        'confidence',
        suggestions.target_page_id.alias('page_id'),
        suggestions.target_page_rev_id.alias('page_rev'),
        F.lit(shared.create_dataset_id()).alias('id'),
        F.lit('commonswiki').alias('origin_wiki'),
    ).distinct()


def parse_args() -> argparse.Namespace:  # pragma: no cover
    description = 'Generate section-level image suggestions based on section topics and section alignment'

    # Required
    parser = shared.build_base_arg_parser(description)
    parser.add_argument(
        'topics',
        metavar='/path/to/topics_parquet',
        help='HDFS path to parquet of section topics',
    )
    parser.add_argument(
        'alignment',
        metavar='/path/to/alignment_parquet',
        help='HDFS path to parquet of section-alignment suggestions',
    )
    parser.add_argument(
        'images',
        metavar='/path/to/images_parquet',
        help='HDFS path to parquet of section images',
    )

    # Optional
    parser.add_argument(
        '-o',
        '--output',
        metavar='/path/to/output_parquet',
        help="HDFS path to output parquet. If passed, output won't be stored in Hive",
    )
    parser.add_argument(
        '-d',
        '--denylist',
        metavar='hdfs_path/to/parquet',
        default=SECTIONS_DENYLIST_PARQUET,
        help=(
            'HDFS path to parquet with a dataframe containing a list of section titles to exclude. '
            f'Default: see "{SECTIONS_DENYLIST_PARQUET}"'
        ),
    )
    parser.add_argument(
        '-s',
        '--score',
        metavar='N',
        default=CONFIDENCE_THRESHOLD,
        help=f'Filter out suggestions with confidence score below this integer. Default: {CONFIDENCE_THRESHOLD}',
    )

    return parser.parse_args()


def main(args: argparse.Namespace, spark: SparkSession) -> None:  # pragma: no cover
    hive_db = args.hive_db
    snapshot = args.snapshot
    coalesce = args.coalesce
    score = args.score
    output = args.output

    raw_suggestions = gather_suggestions(
        spark,
        hive_db,
        snapshot,
        args.topics,
        args.alignment,
        args.images,
        args.denylist,
    )
    confident_suggestions = filter_by_score(raw_suggestions, score)
    suggestions = format_suggestions(confident_suggestions)

    if output:
        suggestions.write.parquet(output, mode='overwrite')
    else:
        shared.save_suggestions_and_cache(
            spark, suggestions, hive_db, snapshot, coalesce
        )


if __name__ == '__main__':
    args = parse_args()
    # Prod
    spark = shared.build_spark_session()
    # Dev
    # spark = shared.build_spark_session(environment='dev', dev_spark_settings=DEV_SPARK_SETTINGS)
    main(args, spark)
    spark.stop()
